import { _decorator, Node, Component, misc } from 'cc';
const { ccclass, property } = _decorator;

@ccclass('CameraFollowing')
export default class CameraFollowing extends Component {
    public static Instance: CameraFollowing = null;

    @property(Node)
    public player: Node = null;

    protected onLoad(): void {
        if (CameraFollowing.Instance) {
            // Đảm bảo chỉ có một instance duy nhất
            this.destroy();
            return;
        }
        CameraFollowing.Instance = this;
    }

    public SetTarget(player: Node): void {
        this.player = player;
    }

    protected update(dt: number): void {
        if (this.player == null) return;

        let targetPos = this.player.getPosition();
        targetPos.y == misc.clampf(targetPos.y, 0, 220);

        let currentPos = this.node.getPosition();
        currentPos.lerp(targetPos, 0.1);
        this.node.setPosition(currentPos);
    }

    protected onDestroy(): void {
        if (CameraFollowing.Instance === this) {
            CameraFollowing.Instance = null;
        }
    }
}
