import {Prefab, instantiate, _decorator, Component, Node, director} from 'cc';

import { PlayerModel } from '../../../Player/Scripts/Models/PlayerModel';
import { PlayerController } from '../../../Player/Scripts/Controllers/PlayerController';
import CameraFollowing from '../../../Camera/CameraFollowing';
const { ccclass, property } = _decorator;

@ccclass('GameManager')
export class GameManager extends Component {
    @property(Prefab)
    public playerPrefab: Node = null;
    @property(Node)
    public playerSpawnNode: Node = null;
    start() {
        this.spawnPlayer();
    }
    update(deltaTime: number) {
    }
    private spawnPlayer(): void {
        var player = instantiate(this.playerPrefab);
        player.setPosition(0, 0, 0);
        
        this.playerSpawnNode.addChild(player);
        this.setPlayerStats(player);
        CameraFollowing.Instance.SetTarget(player);
    }
    private setPlayerStats(player: Node): void {
        const playerComponent = player.getComponent('PlayerController') as PlayerController;
        // Giả sử playerComponent là instance của class có chứa PlayerModel
        if(playerComponent != null){ //just check, then set with static
            PlayerController.SPlayerModel = new PlayerModel(
                "John Doe",   // playerName
                10,          // level
                1000,         // moveSpeed
                100,         // hp
                20,          // attack
                1.2,         // attackSpeed
                0.15,        // critChance
                2.5,         // critDamage
                1          // weapondId
            );
            
        }
        else{
            console.error("playerComponent is null bro");
        }
    }
}